"use strict";
/*
    This file is part of MUTE-structs.

    Copyright (C) 2017  Matthieu Nicolas, Victorien Elvinger

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
Object.defineProperty(exports, "__esModule", { value: true });
var data_validation_1 = require("../data-validation");
var int32_1 = require("../int32");
var EpochId = /** @class */ (function () {
    function EpochId(replicaNumber, epochNumber) {
        this.replicaNumber = replicaNumber;
        this.epochNumber = epochNumber;
    }
    EpochId.fromPlain = function (o) {
        if (data_validation_1.isObject(o) && int32_1.isInt32(o.replicaNumber) &&
            int32_1.isInt32(o.epochNumber)) {
            return new EpochId(o.replicaNumber, o.epochNumber);
        }
        return null;
    };
    Object.defineProperty(EpochId.prototype, "asStr", {
        get: function () {
            return this.replicaNumber + "," + this.epochNumber;
        },
        enumerable: true,
        configurable: true
    });
    return EpochId;
}());
exports.EpochId = EpochId;
//# sourceMappingURL=epochid.js.map