import { Epoch } from "../../epoch/epoch";
import { IdentifierInterval } from "../../identifierinterval";
import { RenamableReplicableList } from "../../renamablereplicablelist";
import { RenamableListOperation } from "../renamablelistoperation";
import { TextOperation } from "../textoperation";
/**
 * Represents a LogootSplit rename operation.
 */
export declare class LogootSRename extends RenamableListOperation {
    static fromPlain(o: unknown): LogootSRename | null;
    readonly replicaNumber: number;
    readonly clock: number;
    readonly renamedIdIntervals: IdentifierInterval[];
    /**
     * @constructor
     */
    constructor(replicaNumber: number, clock: number, epoch: Epoch, renamedIdIntervals: IdentifierInterval[]);
    readonly author: number;
    execute(renamableList: RenamableReplicableList): TextOperation[];
}
