import { Identifier } from "../identifier";
import { IdentifierInterval } from "../identifierinterval";
export declare class RenamingMap {
    static fromPlain(o: unknown): RenamingMap | null;
    readonly replicaNumber: number;
    readonly clock: number;
    readonly renamedIdIntervals: IdentifierInterval[];
    readonly indexes: number[];
    readonly maxOffset: number;
    constructor(replicaNumber: number, clock: number, renamedIdIntervals: IdentifierInterval[]);
    readonly firstId: Identifier;
    readonly lastId: Identifier;
    readonly newFirstId: Identifier;
    readonly newLastId: Identifier;
    readonly newRandom: number;
    renameId(id: Identifier): Identifier;
    renameIdInterval(idInterval: IdentifierInterval): IdentifierInterval[];
    reverseRenameId(id: Identifier): Identifier;
    hasBeenRenamed(id: Identifier): boolean;
    findIndexOfIdOrPredecessor(id: Identifier): [boolean, number];
    findIndexOfRelevantIdInterval(id: Identifier): number;
    findIdFromIndex(index: number): Identifier;
    findPredecessorAndSuccessorFromIndex(index: number): [Identifier, Identifier];
    findPositionFromIndex(index: number): [number, number];
}
