import { LogootSRopes } from "./logootsropes";
export interface BasicStats {
    min: number;
    max: number;
    mean: number;
    median: number;
    lengthRepartition: Map<number, number>;
}
export declare class Stats {
    readonly documentLength: number;
    readonly treeHeight: number;
    private nodeNumber;
    private nodesStats;
    private identifiersStats;
    private nodeLengths;
    private identifierLengths;
    constructor(rope: LogootSRopes);
    readonly numberOfNodes: number;
    readonly maxNodeLength: number;
    readonly minNodeLength: number;
    readonly meanNodeLength: number;
    readonly medianNodeLength: number;
    readonly repartitionNodeLength: Map<number, number>;
    readonly repartitionNodeLengthString: string;
    readonly maxIdentifierLength: number;
    readonly minIdentifierLength: number;
    readonly meanIdentifierLength: number;
    readonly medianIdentifierLength: number;
    readonly repartitionIdentifierLength: Map<number, number>;
    readonly repartitionIdentifierLengthString: string;
    toString(): string;
    private compute;
    private recCompute;
}
